<div class="row justify-content-center section">
    <div class="col-8">
        <form name="editForm" role="form" novalidate (ngSubmit)="save()" #editForm="ngForm">
            <div class="section-title col-md-12">
                <h3 class="title"><span>Create or edit a User</span></h3>
            </div>
            <div>
                <div>
                    <div class="form-group" [hidden]="!user.id">
                        <label>ID</label>
                        <input type="text" class="form-control" name="id"
                               [(ngModel)]="user.id" readonly>
                    </div>

                    <div class="form-group">
                        <label class="form-control-label">Username</label>
                        <input type="text" class="form-control" name="username" #usernameInput="ngModel"
                               [(ngModel)]="user.username" required minlength="1" maxlength="50"
                               pattern="^[_.@A-Za-z0-9-]*$">

                        <div *ngIf="usernameInput.dirty && usernameInput.invalid">
                            <small class="form-text text-danger"
                                   *ngIf="usernameInput.errors.required">
                                This field is required.
                            </small>

                            <small class="form-text text-danger"
                                   *ngIf="usernameInput.errors.maxlength">
                                This field cannot be longer than 50 characters.
                            </small>

                            <small class="form-text text-danger"
                                   *ngIf="usernameInput.errors.pattern">
                                This field can only contain letters, digits and e-mail addresses.
                            </small>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="form-control-label">First Name</label>
                        <input type="text" class="form-control" name="firstName" #firstNameInput="ngModel"
                               [(ngModel)]="user.person.firstName" maxlength="50">

                        <div *ngIf="firstNameInput.dirty && firstNameInput.invalid">
                            <small class="form-text text-danger"
                                   *ngIf="firstNameInput.errors.maxlength">
                                This field cannot be longer than 50 characters.
                            </small>
                        </div>
                    </div>
                    <div class="form-group">
                        <label>Last Name</label>
                        <input type="text" class="form-control" name="lastName" #lastNameInput="ngModel"
                               [(ngModel)]="user.person.lastName" maxlength="50">

                        <div *ngIf="lastNameInput.dirty && lastNameInput.invalid">
                            <small class="form-text text-danger"
                                   *ngIf="lastNameInput.errors.maxlength">
                                This field cannot be longer than 50 characters.
                            </small>
                        </div>
                    </div>
                    <div class="form-group">
                        <label class="form-control-label">Email</label>
                        <input type="email" class="form-control" name="email" #emailInput="ngModel"
                               [(ngModel)]="user.email" minlength="5" required maxlength="254" email>

                        <div *ngIf="emailInput.dirty && emailInput.invalid">
                            <small class="form-text text-danger"
                                   *ngIf="emailInput.errors.required">
                                This field is required.
                            </small>

                            <small class="form-text text-danger"
                                   *ngIf="emailInput.errors.maxlength">
                                This field cannot be longer than 100 characters.
                            </small>

                            <small class="form-text text-danger"
                                   *ngIf="emailInput.errors.minlength">
                                This field is required to be at least 5 characters.
                            </small>

                            <small class="form-text text-danger"
                                   *ngIf="emailInput.errors.email">
                                Your email is invalid.
                            </small>
                        </div>
                    </div>
                    <div class="form-check">
                        <label class="form-check-label" for="activated">
                            <input class="form-check-input" [disabled]="user.id === null" type="checkbox" id="activated"
                                   name="activated" [(ngModel)]="user.activated">
                            <span>Activated</span>
                        </label>
                    </div>

                    <div class="form-group">
                        <label>Roles</label>
                        <select class="form-control" multiple name="role" [(ngModel)]="user.roles">
                            <option *ngFor="let role of roles" [value]="role">{{role}}</option>
                        </select>
                    </div>
                </div>
                <div>
                    <button type="button" class="btn btn-secondary" (click)="previousState()">
                        <fa-icon [icon]="'ban'"></fa-icon>&nbsp;<span>Cancel</span>
                    </button>
                    <button type="submit" [disabled]="editForm.form.invalid || isSaving" class="btn btn-primary">
                        <fa-icon [icon]="'save'"></fa-icon>&nbsp;<span>Save</span>
                    </button>
                </div>
            </div>
        </form>
    </div>
</div>
